#include "mcc_generated_files/mcc.h"
#include "esp8266.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
// Variablen
volatile uint32_t millis=0;                         // Miilisekunden seit einschalten
//uint8_t Station_IP[]={0,0,0,0};
uint8_t Text_Buffer[21];
char connect=0;
uint16_t lenght=0;
uint8_t status1=0;
uint8_t status2=0;
char zeichen;
volatile uint8_t count_z=0;
volatile uint8_t count=0;
uint8_t data_array[32];

// Prototypen
void Timer0_Int(void);

void main(void)
{
    // Initialize the device
    SYSTEM_Initialize();

    TMR0_SetInterruptHandler(Timer0_Int);
    init_esp8266();
    // Enable the Global Interrupts
    
    INTERRUPT_GlobalInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    PutsUART("AT\r\n");
    if(SearchBuffer("OK"))
        {
        PutsUART("AT+RST\r\n");             // ESP Rcksetzen
        while(!SearchBuffer("ready"));
        PutsUART("AT+CWQAP\r\n");           // Alte Verbindung abbrechen
        while(!SearchBuffer("OK"));
        PutsUART("AT+CWMODE=1\r\n");        // Station Mode
        while(!SearchBuffer("OK"));
        PutsUART("AT+CWJAP=\"");            // Wifi connect
        PutsUART(ssid);
        PutsUART("\",\"");
        PutsUART(passwd);
        PutsUART("\"\r\n");        
        while(!SearchBuffer("OK"));
        PutsUART("AT+CIPMUX=1\r\n");        // Mux =1
        while(!SearchBuffer("OK"));       
        PutsUART("AT+CIPSERVER=1,80\r\n");        // Mux =1
        while(!SearchBuffer("OK"));           
        }

    while (1)
    {
        if(SearchBuffer("+IPD,"))
            {
            BufferOut(&connect);
            if(SearchBuffer2("GET /?"))
            {
            ReadBuffer(&Text_Buffer, 6);
            if(strncmp("B=2",Text_Buffer,3)==0)
                {
                                    status1=0;
                                    data_array[0]=0;

                }
            if(strncmp("B=1",Text_Buffer,3)==0)
                {
                                    status1=1;

                }
            if(strncmp("B=4",Text_Buffer,3)==0)
                {
                                    status2=0;
                                    data_array[1]=0;

                }
            if(strncmp("B=3",Text_Buffer,3)==0)
                {
                                    status2=1;
                                    data_array[1]=1;

                }            
            }

            if(status1==1)
                {
                lenght=strlen(page01);
                }
            else if(status1==0)
                {
                lenght=strlen(page02);
                }
            if(status2==1)
                {
                lenght+=strlen(page04);
                }
            else if(status2==0)
                {
                lenght+=strlen(page05);
                }

            lenght+=strlen(page0);
            lenght+=strlen(page03);
            lenght+=strlen(page06);
            
            sprintf(Text_Buffer,"%u",lenght);
           
            PutsUART("AT+CIPSEND=");        // Mux =1
            PutcUART(connect);        // Mux =1
            PutcUART(',');        // Mux =1
            PutssUART(Text_Buffer);        // Mux =1
            PutsUART("\r\n");        // Mux =1
            while(!SearchBuffer(">"));             
            PutsUART(page0);        // Mux =1
            if(status1==1)
                {
                PutsUART(page01);
                }
            else if(status1==0)
                {
                PutsUART(page02);
                }
            PutsUART(page03);        // Mux =1            
            if(status2==1)
                {
                PutsUART(page04);
                }
            else if(status2==0)
                {
                PutsUART(page05);
                }      
            PutsUART(page06);        // Mux =1              
            SearchBuffer("SEND OK"); 
            PutsUART("AT+CIPCLOSE=");        // Mux =1
            //PutcUART(connect);        // Mux =1
            PutcUART(connect);        // Mux =1
            PutsUART("\r\n");               
            SearchBuffer("unlink"); 
            BufferClr();
        }
        data_array[2]=count;
    }
}

void Timer0_Int(void)
{
    millis++;
    if(count_z<100)
        {
        count_z++;
        }
    else
        {
        count_z=0;
count++;
    }
}